Index: uspace/app/display-cfg/test/display-cfg.c
===================================================================
--- uspace/app/display-cfg/test/display-cfg.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/display-cfg/test/display-cfg.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <pcut/pcut.h>
+#include <ui/ui.h>
+#include "../display-cfg.h"
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(display_cfg);
+
+/** Test display_cfg_create() and display_cfg_destroy() */
+PCUT_TEST(create_destroy)
+{
+	display_cfg_t *dcfg;
+	errno_t rc;
+
+	rc = display_cfg_create(UI_DISPLAY_NULL, &dcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	display_cfg_destroy(dcfg);
+}
+
+PCUT_EXPORT(display_cfg);
Index: uspace/app/display-cfg/test/main.c
===================================================================
--- uspace/app/display-cfg/test/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/display-cfg/test/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,36 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <pcut/pcut.h>
+
+PCUT_INIT;
+
+PCUT_IMPORT(display_cfg);
+PCUT_IMPORT(seats);
+
+PCUT_MAIN();
Index: uspace/app/display-cfg/test/seats.c
===================================================================
--- uspace/app/display-cfg/test/seats.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/display-cfg/test/seats.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,274 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <async.h>
+#include <dispcfg.h>
+#include <dispcfg_srv.h>
+#include <errno.h>
+#include <pcut/pcut.h>
+#include <str.h>
+#include <testdc.h>
+#include "../display-cfg.h"
+#include "../seats.h"
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(seats);
+
+static const char *test_dispcfg_server = "test-dispcfg";
+static const char *test_dispcfg_svc = "test/dispcfg";
+
+/** Test dcfg_seats_create() and dcfg_seats_destroy() */
+PCUT_TEST(create_destroy)
+{
+	display_cfg_t *dcfg;
+	dcfg_seats_t *seats;
+	errno_t rc;
+
+	rc = display_cfg_create(UI_DISPLAY_NULL, &dcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_seats_create(dcfg, &seats);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	dcfg_seats_destroy(seats);
+	display_cfg_destroy(dcfg);
+}
+
+/** dcfg_seats_insert() inserts an entry into the seat list */
+PCUT_TEST(seats_insert)
+{
+	display_cfg_t *dcfg;
+	dcfg_seats_t *seats;
+	dcfg_seats_entry_t *entry = NULL;
+	errno_t rc;
+
+	rc = display_cfg_create(UI_DISPLAY_NULL, &dcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_seats_create(dcfg, &seats);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_seats_insert(seats, "Alice", 42, &entry);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(entry);
+
+	PCUT_ASSERT_STR_EQUALS("Alice", entry->name);
+	PCUT_ASSERT_INT_EQUALS(42, entry->seat_id);
+
+	dcfg_seats_destroy(seats);
+	display_cfg_destroy(dcfg);
+}
+
+/** dcfg_seats_list_populate() populates seat list */
+PCUT_TEST(seats_list_populate)
+{
+	display_cfg_t *dcfg;
+	dcfg_seats_t *seats;
+	errno_t rc;
+	service_id_t sid;
+	test_response_t resp;
+	loc_srv_t *srv;
+
+	async_set_fallback_port_handler(test_dispcfg_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_dispcfg_server, &srv);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(srv, test_dispcfg_svc, &sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = display_cfg_create(UI_DISPLAY_NULL, &dcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = display_cfg_open(dcfg, test_dispcfg_svc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_seats_create(dcfg, &seats);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/*
+	 * dcfg_seat_list_populate() calls dispcfg_get_seat_list()
+	 * and dispcfg_get_seat_info()
+	 */
+	resp.rc = EOK;
+	resp.get_seat_list_rlist = calloc(1, sizeof(dispcfg_seat_list_t));
+	PCUT_ASSERT_NOT_NULL(resp.get_seat_list_rlist);
+	resp.get_seat_list_rlist->nseats = 1;
+	resp.get_seat_list_rlist->seats = calloc(1, sizeof(sysarg_t));
+	PCUT_ASSERT_NOT_NULL(resp.get_seat_list_rlist->seats);
+	resp.get_seat_list_rlist->seats[0] = 42;
+
+	resp.get_seat_info_rinfo = calloc(1, sizeof(dispcfg_seat_info_t));
+	PCUT_ASSERT_NOT_NULL(resp.get_seat_info_rinfo);
+	resp.get_seat_info_rinfo->name = str_dup("Alice");
+	PCUT_ASSERT_NOT_NULL(resp.get_seat_info_rinfo->name);
+
+	rc = dcfg_seats_list_populate(seats);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	dcfg_seats_destroy(seats);
+	display_cfg_destroy(dcfg);
+
+	rc = loc_service_unregister(srv, sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	loc_server_unregister(srv);
+}
+
+/** dcfg_devices_insert() inserts an entry into the device list */
+PCUT_TEST(devices_insert)
+{
+	display_cfg_t *dcfg;
+	dcfg_seats_t *seats;
+	ui_list_entry_t *lentry;
+	dcfg_devices_entry_t *entry;
+	errno_t rc;
+
+	rc = display_cfg_create(UI_DISPLAY_NULL, &dcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_seats_create(dcfg, &seats);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_devices_insert(seats, "mydevice", 42);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	lentry = ui_list_first(seats->device_list);
+	PCUT_ASSERT_NOT_NULL(lentry);
+	entry = (dcfg_devices_entry_t *)ui_list_entry_get_arg(lentry);
+	PCUT_ASSERT_NOT_NULL(entry);
+
+	PCUT_ASSERT_STR_EQUALS("mydevice", entry->name);
+	PCUT_ASSERT_INT_EQUALS(42, entry->svc_id);
+
+	dcfg_seats_destroy(seats);
+	display_cfg_destroy(dcfg);
+}
+
+/** dcfg_avail_devices_insert() inserts entry into available devices list */
+PCUT_TEST(avail_devices_insert)
+{
+	display_cfg_t *dcfg;
+	dcfg_seats_t *seats;
+	ui_list_entry_t *lentry;
+	dcfg_devices_entry_t *entry;
+	ui_select_dialog_t *dialog;
+	ui_select_dialog_params_t sdparams;
+	errno_t rc;
+
+	rc = display_cfg_create(UI_DISPLAY_NULL, &dcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_seats_create(dcfg, &seats);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_select_dialog_params_init(&sdparams);
+	sdparams.caption = "Dialog";
+	sdparams.prompt = "Select";
+
+	rc = ui_select_dialog_create(seats->dcfg->ui, &sdparams, &dialog);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = dcfg_avail_devices_insert(seats, dialog, "mydevice", 42);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	lentry = ui_list_first(ui_select_dialog_list(dialog));
+	PCUT_ASSERT_NOT_NULL(lentry);
+	entry = (dcfg_devices_entry_t *)ui_list_entry_get_arg(lentry);
+	PCUT_ASSERT_NOT_NULL(entry);
+
+	PCUT_ASSERT_STR_EQUALS("mydevice", entry->name);
+	PCUT_ASSERT_INT_EQUALS(42, entry->svc_id);
+
+	ui_select_dialog_destroy(dialog);
+	dcfg_seats_destroy(seats);
+	display_cfg_destroy(dcfg);
+}
+
+PCUT_TEST(asgn_dev_list_populate)
+{
+}
+
+PCUT_TEST(avail_dev_list_populate)
+{
+}
+
+PCUT_TEST(seats_get_selected)
+{
+}
+
+PCUT_TEST(devices_get_selected)
+{
+}
+
+PCUT_TEST(seats_list_selected)
+{
+}
+
+PCUT_TEST(add_seat_clicked)
+{
+}
+
+PCUT_TEST(remove_seat_clicked)
+{
+}
+
+PCUT_TEST(add_seat_dialog_bok)
+{
+}
+
+PCUT_TEST(add_seat_dialog_bcancel)
+{
+}
+
+PCUT_TEST(add_seat_dialog_close)
+{
+}
+
+PCUT_TEST(add_device_clicked)
+{
+}
+
+PCUT_TEST(remove_device_clicked)
+{
+}
+
+PCUT_TEST(add_device_dialog_bok)
+{
+}
+
+PCUT_TEST(add_device_dialog_bcancel)
+{
+}
+
+PCUT_TEST(add_device_dialog_close)
+{
+}
+
+PCUT_EXPORT(seats);
Index: uspace/app/display-cfg/types/display-cfg.h
===================================================================
--- uspace/app/display-cfg/types/display-cfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/display-cfg/types/display-cfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,65 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup display-cfg
+ * @{
+ */
+/**
+ * @file Display configuration utility (UI) types
+ */
+
+#ifndef TYPES_DISPLAY_CFG_H
+#define TYPES_DISPLAY_CFG_H
+
+#include <dispcfg.h>
+#include <ui/fixed.h>
+#include <ui/label.h>
+#include <ui/tabset.h>
+#include <ui/ui.h>
+#include <ui/window.h>
+
+/** Display configuration utility (UI) */
+typedef struct display_cfg {
+	/** Display configuration session */
+	dispcfg_t *dispcfg;
+	/** UI */
+	ui_t *ui;
+	/** Containing window */
+	ui_window_t *window;
+	/** Fixed layout */
+	ui_fixed_t *fixed;
+	/** Tab set */
+	ui_tab_set_t *tabset;
+	/** Seat configuration tab */
+	struct dcfg_seats *seats;
+} display_cfg_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/app/display-cfg/types/seats.h
===================================================================
--- uspace/app/display-cfg/types/seats.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/display-cfg/types/seats.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,106 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup display-cfg
+ * @{
+ */
+/**
+ * @file Seat configuration tab
+ */
+
+#ifndef TYPES_SEATS_H
+#define TYPES_SEATS_H
+
+#include <loc.h>
+#include <types/common.h>
+#include <ui/fixed.h>
+#include <ui/label.h>
+#include <ui/list.h>
+#include <ui/pbutton.h>
+#include <ui/promptdialog.h>
+#include <ui/selectdialog.h>
+#include <ui/tab.h>
+
+/** Seat configuration tab */
+typedef struct dcfg_seats {
+	/** Containing display configuration */
+	struct display_cfg *dcfg;
+	/** UI tab */
+	ui_tab_t *tab;
+	/** Fixed layout */
+	ui_fixed_t *fixed;
+	/** 'Configured seats' label */
+	ui_label_t *seats_label;
+	/** List of configured seats */
+	ui_list_t *seat_list;
+	/** Add seat button */
+	ui_pbutton_t *add_seat;
+	/** Remove seat button */
+	ui_pbutton_t *remove_seat;
+	/** Add seat dialog */
+	ui_prompt_dialog_t *add_seat_dlg;
+	/** 'Devices assigned to xxx' label */
+	ui_label_t *devices_label;
+	/** List of assigned devices */
+	ui_list_t *device_list;
+	/** Add device button */
+	ui_pbutton_t *add_device;
+	/** Remove device button */
+	ui_pbutton_t *remove_device;
+	/** Add device dialog */
+	ui_select_dialog_t *add_device_dlg;
+} dcfg_seats_t;
+
+/** Entry in seat list */
+typedef struct {
+	/** Containing seat configuration tab */
+	struct dcfg_seats *seats;
+	/** List entry */
+	ui_list_entry_t *lentry;
+	/** Seat ID */
+	sysarg_t seat_id;
+	/** Seat name */
+	char *name;
+} dcfg_seats_entry_t;
+
+/** Entry in device list */
+typedef struct {
+	/** Containing seat configuration tab */
+	struct dcfg_seats *seats;
+	/** List entry */
+	ui_list_entry_t *lentry;
+	/** Service ID */
+	service_id_t svc_id;
+	/** Device name */
+	char *name;
+} dcfg_devices_entry_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/app/dltest/dltest.c
===================================================================
--- uspace/app/dltest/dltest.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/dltest/dltest.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2016 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -571,4 +571,29 @@
 #ifdef DLTEST_LINKED
 
+/** Test if we can read the correct value of a public pointer variable.
+ *
+ * dl_public_ptr_var is initialized in libdltest to point to dl_public_var.
+ * This is done using a relocation. The main program (unless compiled with
+ * PIC or PIE) will contain a copy of dl_public_ptr_var. This needs
+ * to be copied using a COPY relocation. The relocations in the main
+ * program need to be processed after the relocations in the shared
+ * libraries (so that we copy the correct value).
+ */
+static bool test_public_ptr_var(void)
+{
+	int *ptr;
+
+	printf("Read dl_public_ptr_var directly...\n");
+	ptr = dl_public_ptr_var;
+
+	if (ptr != &dl_public_var) {
+		printf("FAILED\n");
+		return false;
+	}
+
+	printf("Passed\n");
+	return true;
+}
+
 /** Test directly calling function that returns a constant */
 static bool test_lnk_dl_get_constant(void)
@@ -920,4 +945,5 @@
 
 #ifndef STATIC_EXE
+
 	if (!test_dlfcn_dl_get_private_fib_var())
 		return 1;
@@ -974,4 +1000,7 @@
 
 	if (!test_lnk_read_public_uvar())
+		return 1;
+
+	if (!test_public_ptr_var())
 		return 1;
 
Index: uspace/app/edit/edit.c
===================================================================
--- uspace/app/edit/edit.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/edit/edit.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2012 Martin Sucha
  * All rights reserved.
@@ -60,4 +60,5 @@
 #include <ui/menu.h>
 #include <ui/menubar.h>
+#include <ui/menudd.h>
 #include <ui/menuentry.h>
 #include <ui/promptdialog.h>
@@ -237,9 +238,21 @@
 
 static void edit_wnd_close(ui_window_t *, void *);
+static void edit_wnd_focus(ui_window_t *, void *, unsigned);
 static void edit_wnd_kbd_event(ui_window_t *, void *, kbd_event_t *);
+static void edit_wnd_unfocus(ui_window_t *, void *, unsigned);
 
 static ui_window_cb_t edit_window_cb = {
 	.close = edit_wnd_close,
-	.kbd = edit_wnd_kbd_event
+	.focus = edit_wnd_focus,
+	.kbd = edit_wnd_kbd_event,
+	.unfocus = edit_wnd_unfocus
+};
+
+static void edit_menubar_activate(ui_menu_bar_t *, void *);
+static void edit_menubar_deactivate(ui_menu_bar_t *, void *);
+
+static ui_menu_bar_cb_t edit_menubar_cb = {
+	.activate = edit_menubar_activate,
+	.deactivate = edit_menubar_deactivate
 };
 
@@ -430,5 +443,7 @@
 	}
 
-	rc = ui_menu_create(edit->menubar, "File", &mfile);
+	ui_menu_bar_set_cb(edit->menubar, &edit_menubar_cb, (void *) edit);
+
+	rc = ui_menu_dd_create(edit->menubar, "~F~ile", NULL, &mfile);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -436,5 +451,5 @@
 	}
 
-	rc = ui_menu_entry_create(mfile, "Save", "Ctrl-S", &msave);
+	rc = ui_menu_entry_create(mfile, "~S~ave", "Ctrl-S", &msave);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -444,5 +459,5 @@
 	ui_menu_entry_set_cb(msave, edit_file_save, (void *) edit);
 
-	rc = ui_menu_entry_create(mfile, "Save As", "Ctrl-E", &msaveas);
+	rc = ui_menu_entry_create(mfile, "Save ~A~s", "Ctrl-E", &msaveas);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -458,5 +473,5 @@
 	}
 
-	rc = ui_menu_entry_create(mfile, "Exit", "Ctrl-Q", &mexit);
+	rc = ui_menu_entry_create(mfile, "E~x~it", "Ctrl-Q", &mexit);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -466,5 +481,5 @@
 	ui_menu_entry_set_cb(mexit, edit_file_exit, (void *) edit);
 
-	rc = ui_menu_create(edit->menubar, "Edit", &medit);
+	rc = ui_menu_dd_create(edit->menubar, "~E~dit", NULL, &medit);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -472,5 +487,5 @@
 	}
 
-	rc = ui_menu_entry_create(medit, "Cut", "Ctrl-X", &mcut);
+	rc = ui_menu_entry_create(medit, "Cu~t~", "Ctrl-X", &mcut);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -480,5 +495,5 @@
 	ui_menu_entry_set_cb(mcut, edit_edit_cut, (void *) edit);
 
-	rc = ui_menu_entry_create(medit, "Copy", "Ctrl-C", &mcopy);
+	rc = ui_menu_entry_create(medit, "~C~opy", "Ctrl-C", &mcopy);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -488,5 +503,5 @@
 	ui_menu_entry_set_cb(mcopy, edit_edit_copy, (void *) edit);
 
-	rc = ui_menu_entry_create(medit, "Paste", "Ctrl-V", &mpaste);
+	rc = ui_menu_entry_create(medit, "~P~aste", "Ctrl-V", &mpaste);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -496,5 +511,5 @@
 	ui_menu_entry_set_cb(mpaste, edit_edit_paste, (void *) edit);
 
-	rc = ui_menu_entry_create(medit, "Delete", "Del", &mdelete);
+	rc = ui_menu_entry_create(medit, "~D~elete", "Del", &mdelete);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -510,5 +525,5 @@
 	}
 
-	rc = ui_menu_entry_create(medit, "Select All", "Ctrl-A", &mselall);
+	rc = ui_menu_entry_create(medit, "Select ~A~ll", "Ctrl-A", &mselall);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -518,5 +533,5 @@
 	ui_menu_entry_set_cb(mselall, edit_edit_select_all, (void *) edit);
 
-	rc = ui_menu_create(edit->menubar, "Search", &msearch);
+	rc = ui_menu_dd_create(edit->menubar, "~S~earch", NULL, &msearch);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -524,5 +539,5 @@
 	}
 
-	rc = ui_menu_entry_create(msearch, "Find", "Ctrl-F", &mfind);
+	rc = ui_menu_entry_create(msearch, "~F~ind", "Ctrl-F", &mfind);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -532,5 +547,5 @@
 	ui_menu_entry_set_cb(mfind, edit_search_find, (void *) edit);
 
-	rc = ui_menu_entry_create(msearch, "Reverse Find", "Ctrl-Shift-F", &mfindr);
+	rc = ui_menu_entry_create(msearch, "~R~everse Find", "Ctrl-Shift-F", &mfindr);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -540,5 +555,5 @@
 	ui_menu_entry_set_cb(mfindr, edit_search_reverse_find, (void *) edit);
 
-	rc = ui_menu_entry_create(msearch, "Find Next", "Ctrl-N", &mfindn);
+	rc = ui_menu_entry_create(msearch, "Find ~N~ext", "Ctrl-N", &mfindn);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -554,5 +569,5 @@
 	}
 
-	rc = ui_menu_entry_create(msearch, "Go To Line", "Ctrl-L", &mgoto);
+	rc = ui_menu_entry_create(msearch, "Go To ~L~ine", "Ctrl-L", &mgoto);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -978,5 +993,5 @@
 
 		bcnt -= off;
-		memcpy(buf, buf + off, bcnt);
+		memmove(buf, buf + off, bcnt);
 
 		insert_char(c);
@@ -1259,4 +1274,5 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.font = font;
 	fmt.color = pane->color;
 
@@ -1318,5 +1334,5 @@
 					return rc;
 
-				rc = gfx_puttext(font, &tpos, &fmt, cbuf);
+				rc = gfx_puttext(&tpos, &fmt, cbuf);
 				if (rc != EOK)
 					return rc;
@@ -1408,6 +1424,6 @@
 	 */
 	while (true) {
-		int rc = asprintf(&text, "%d, %d (%d): File '%s'. Ctrl-Q Quit  Ctrl-S Save  "
-		    "Ctrl-E Save As", coord.row, coord.column, last_row, fname);
+		int rc = asprintf(&text, "%d, %d (%d): File '%s'. Ctrl-Q Quit  "
+		    "F10 Menu", coord.row, coord.column, last_row, fname);
 		if (rc < 0) {
 			n = 0;
@@ -2219,4 +2235,19 @@
 }
 
+/** Window focus event
+ *
+ * @param window Window
+ * @param arg Argument (edit_t *)
+ * @param focus Focus number
+ */
+static void edit_wnd_focus(ui_window_t *window, void *arg, unsigned focus)
+{
+	edit_t *edit = (edit_t *)arg;
+
+	(void)edit;
+	pane_caret_display(&pane);
+	cursor_setvis(true);
+}
+
 /** Window keyboard event
  *
@@ -2229,4 +2260,7 @@
 {
 	pane.keymod = event->mods;
+
+	if (ui_window_def_kbd(window, event) == ui_claimed)
+		return;
 
 	if (event->type == KEY_PRESS) {
@@ -2237,4 +2271,45 @@
 }
 
+/** Window unfocus event
+ *
+ * @param window Window
+ * @param arg Argument (edit_t *)
+ * @param focus Focus number
+ */
+static void edit_wnd_unfocus(ui_window_t *window, void *arg, unsigned focus)
+{
+	edit_t *edit = (edit_t *) arg;
+
+	(void)edit;
+	cursor_setvis(false);
+}
+
+/** Menu bar activate event
+ *
+ * @param mbar Menu bar
+ * @param arg Argument (edit_t *)
+ */
+static void edit_menubar_activate(ui_menu_bar_t *mbar, void *arg)
+{
+	edit_t *edit = (edit_t *)arg;
+
+	(void)edit;
+	cursor_setvis(false);
+}
+
+/** Menu bar deactivate event
+ *
+ * @param mbar Menu bar
+ * @param arg Argument (edit_t *)
+ */
+static void edit_menubar_deactivate(ui_menu_bar_t *mbar, void *arg)
+{
+	edit_t *edit = (edit_t *)arg;
+
+	(void)edit;
+	pane_caret_display(&pane);
+	cursor_setvis(true);
+}
+
 /** File / Save menu entry selected.
  *
@@ -2402,13 +2477,9 @@
 {
 	edit_t *edit = (edit_t *)arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
 	char *cname;
 	errno_t rc;
 
+	(void)edit;
 	ui_file_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
 
 	cname = str_dup(fname);
@@ -2436,11 +2507,7 @@
 {
 	edit_t *edit = (edit_t *)arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
+
+	(void)edit;
 	ui_file_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
 }
 
@@ -2453,11 +2520,7 @@
 {
 	edit_t *edit = (edit_t *)arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
+
+	(void)edit;
 	ui_file_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
 }
 
@@ -2472,5 +2535,4 @@
 {
 	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
 	char *endptr;
 	int line;
@@ -2484,8 +2546,6 @@
 
 	caret_move_absolute(line, pane.ideal_column, dir_before, false);
-	// TODO Smarter cursor management
+	(void)edit;
 	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
-	(void) gfx_update(gc);
 }
 
@@ -2498,11 +2558,7 @@
 {
 	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
+
+	(void)edit;
 	ui_prompt_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
 }
 
@@ -2515,11 +2571,7 @@
 {
 	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
+
+	(void)edit;
 	ui_prompt_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
 }
 
@@ -2534,8 +2586,8 @@
 {
 	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
 	char *pattern;
 	bool reverse;
 
+	(void)edit;
 	ui_prompt_dialog_destroy(dialog);
 
@@ -2554,8 +2606,5 @@
 	search(pattern, reverse);
 
-	// TODO Smarter cursor management
 	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
-	(void) gfx_update(gc);
 }
 
@@ -2568,11 +2617,7 @@
 {
 	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
+
+	(void)edit;
 	ui_prompt_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
 }
 
@@ -2585,11 +2630,7 @@
 {
 	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
+
+	(void)edit;
 	ui_prompt_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
 }
 
